#!/usr/bin/perl
#
# tarot.cgi
# (c) Chris Young <chris@unsatisfactorysoftware.co.uk>
# No warranties expressed or implied, all use is at your own risk!

srand(time ^ $$);
&parse_form;
$type = $FORM{'type'};
$cardfile = $FORM{'cards'};

if (!$type)
{
    print "Location: http://www.unsatisfactorysoftware.co.uk/tarot/\n\n";
    exit;
}

$lock = 2;
$unlock = 8;
$delimiter = "|";

open(FILE,$cardfile);
flock(FILE,$lock);
@cards = <FILE>;
flock(FILE,$unlock);
close(FILE);

# shuffle the deck

for ($deck = 0; $deck < @cards; ++$deck)
{
    $card[$deck] = rand(@cards);
    
    for ($test = 0; $test < $deck; ++$test)
    {
        if ($cards[$card[$deck]] eq $cards[$card[$test]])
        {
            $card[$deck] = rand(@cards);
            $test=-1;
        }
    }
    
}

#

print "Content-type: text/html\n\n";

print <<HEADER;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
"http://www.w3.org/TR/REC-html40/loose.dtd">
<html>
<head>
<title>Electronic Tarot</title>
<link rel="stylesheet" href="tarot.css" type="text/css">
</head>
<body bgcolor="#000000" link="#B53EFF" vlink="#B53EFF" alink="#FF8800" text="#FFFFFF">
<b>Electronic Tarot</b>

<p align=justify>Below is your Tarot card reading.

<p><ul>
<li><a href="index.html">I want another reading</a>
</ul>
<hr>
<table border=1 width="100%">
<tr><td width="33%">Past<td width="33%">Present<td width="33%">Future
<tr>
HEADER

# for ($deck = 0; $deck < @cards; ++$deck)
# {
#   @descrip = split(/\|/,$cards[$card[$deck]]);
#   print "$descrip[0]<br>\n";
# }

for ($deal = 0; $deal < 3; ++$deal)
{
    @descrip = split(/\|/,$cards[$card[$deal]]);
    
    $rev[$deal] = rand(2);
    print "<th bgcolor=\"#003300\">";

    if ($rev[$deal]<1)
    {
        print "$descrip[0]<br>";
    }
    else
    {
        print "reversed $descrip[0]<br>";
    }
}

print "<tr>";
for ($deal = 0; $deal < 3; ++$deal)
{
    @descrip = split(/\|/,$cards[$card[$deal]]);
    print "<td align=center>";

    if ($rev[$deal]<1)
    {
        print "$descrip[1]<br>";
    }
    else
    {
        if ($descrip[2])
        {
            print "$descrip[2]<br>";
        }
        else
        {
            print "$descrip[1]<br>";
        }
    }
}

print <<GENPAGE;
</table>
<hr>
<font size=2>&copy; 1999 <a href="http://www.unsatisfactorysoftware.co.uk">Unsatisfactory Software</a></font>
</body>
</html>
GENPAGE

##
sub parse_form {

   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   if (length($buffer) < 5) {
     $buffer = $ENV{QUERY_STRING};
    }

  @pairs = split(/&/, $buffer);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);

      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

      $FORM{$name} = $value;
   }
}


